﻿using System;
using System.Data;

using System.Transactions;
using System.Data.SqlClient;

public class Class1
{
    private string strConnString = System.Configuration.ConfigurationManager.ConnectionStrings["Conn_Northwind"].ToString();

    public Class1()
    {
    }

    public string func1()
    {
        SqlConnection conn = null;
        SqlCommand cmd = null;
        int intTheNewestID = 0;
        string strReturn = "";

        //Insert 后，立即 Select 出数据库最新插入的这一笔记录，其 id 值 (identity, 由数据库自动增号)
        string strSql = "INSERT INTO Employees (LastName, FirstName) VALUES('Wu', 'Wizard') ; SELECT @@identity; ";

        //Required 选项: 当前环境若无事务，则创建新事务，否则就加入当前环境的同一个事务
        using (TransactionScope scope = new TransactionScope(TransactionScopeOption.Required))
        {
            try
            {
                conn = new SqlConnection(strConnString);
                conn.Open();
                if (conn.State == ConnectionState.Open)
                {
                    cmd = new SqlCommand(strSql, conn);
                    intTheNewestID = Convert.ToInt32(cmd.ExecuteScalar());

                    //调用 Class 2 的函数，将其也加入同一个事务
                    Class2 c2 = new Class2();
                    strReturn = c2.func2(intTheNewestID);

                    scope.Complete();
                }
            }
            catch (Exception ex)
            {
                throw new Exception("组件一 - 发生数据库访问错误: " + ex.ToString());
            }
            finally
            {
                if (cmd != null)
                    cmd.Dispose();
                if (conn.State == ConnectionState.Open)
                {
                    conn.Close();
                }
                conn.Dispose();
            }
        }

        return strReturn;    //返回前台的网页中显示
    }





}
