﻿using System;

using System.Data;
using System.Transactions;
using System.Data.SqlClient;

public partial class _Default : System.Web.UI.Page 
{
    private string strConnString = System.Configuration.ConfigurationManager.ConnectionStrings["Conn_Northwind"].ToString();

    protected void Page_Load(object sender, EventArgs e)
    {
    }

    protected void Button1_Click(object sender, EventArgs e)
    {
        SqlConnection conn = null;
        SqlCommand cmd = null;

        string strSql = "INSERT INTO Employees (LastName, FirstName) VALUES('Wu', 'Wizard')";

        //用 CommittableTransaction 进行明确式事务
        using (CommittableTransaction tran = new CommittableTransaction())
        {
            try
            {
                conn = new SqlConnection(strConnString);
                conn.Open();
                conn.EnlistTransaction(tran);
                if (conn.State == ConnectionState.Open)
                {
                    cmd = new SqlCommand(strSql, conn);
                    cmd.ExecuteNonQuery();

                    //指定 Callback 函数为 OnCommitted
                    AsyncCallback ac = new AsyncCallback(OnCommitted);
                    tran.BeginCommit(ac, null);    //开始一个异步事务

                    //tran.Commit();    //同步事务的写法
                }
            }
            catch (Exception ex)
            {
                tran.Rollback();
                Response.Write("程序发生错误: " + ex.Message);
            }
            finally
            {
                if (cmd != null)
                    cmd.Dispose();
                if (conn.State == ConnectionState.Open)
                {
                    conn.Close();
                }
                conn.Dispose();
            }
        }
    }

    //执行到这个方法时，会从 Thread Pool 里取得一条线程，进行异步的事务
    private void OnCommitted(IAsyncResult ar)     //传入一个 IAsyncResult 参数
    {
        CommittableTransaction Tx;
        Tx = (CommittableTransaction)ar;

        try
        {
            using ((Tx))
            {
                Tx.EndCommit(ar);    //结束异步事务
            }

            Response.Write("异步事务完成，已成功插入一条记录。");
        }
        catch (TransactionException ex)
        {
            Tx.Rollback();
            Response.Write("异步事务失败，错误信息为：" + ex.Message);
        }
        finally
        {
            if (Tx != null)
                Tx.Dispose();
        }
    }

}
